/*	
*	Clip.c -- clip management accessory
*	 1997 Michael Rees
*/

/*
============================================================================
|    DATE    | WHAT
============================================================================
  11 Feb 97  | created
  13 Feb 97  | reset window pointer in settags() dipshit.
*/

#define DBUG 1
//#define FILEDUMP

#define ACC_NAME WTITLE

#include <exec/exec.h>
#include <exec/types.h>
#include <exec/memory.h>
#include <dos/dos.h>
#include <intuition/intuition.h>
#include <libraries/asl.h>
#include <string.h>
//#include <stdio.h>

#include <proto/exec.h>
#include <clib/dos_protos.h>
#include <proto/intuition.h>
#include <proto/graphics.h>
#include <proto/asl.h>
#include <clib/alib_protos.h>
#include <clib/alib_stdio_protos.h>

#include "bars.h"
#include "bplib.h"
#include "barsmacros.h"
#include "proto/bplib_protos.h"
#include "proto/clip_protos.h"
#include "ToolID.h"
#include "debug.h"

/* for building an array of clips' filenames for saving a list file */
struct Name {
	struct Name *next;
	char *name;
};

/* file id for a clip list file ("ClLt") */
#define LISTID 0x436C4C74

static UBYTE const versiontag[] = "$VER: Clip_Thing 40.1 (13.06.97)";

#include "clipw.h"
#include "/icons/ClipAccIcons.h"

extern struct IntuitionBase *IntuitionBase;
extern struct GfxBase *GfxBase;
extern struct LayersBase *LayersBase;
extern struct DOSBase *DOSBase;
extern struct ExecBase *SysBase;
extern struct Functions *functions;

static struct Clipper {
	struct Accessory access;
	WORD left;   // asl requester position & size
	WORD top;
	UWORD width;
	UWORD height;
	char drawer[100];
} Clipper;

#define DATA_SIZE (sizeof(struct Clipper)-sizeof(struct Accessory) + 4)
/*
-sizeof(struct FileRequester *) + 4)
*/
#define awin Clipper.access.window
#define DEFAULT_LEFT   100
#define DEFAULT_TOP     12
#define DEFAULT_WIDTH  345
#define DEFAULT_HEIGHT 175
#define DEFAULT_PATTERN "#?.clip"
#define DEFAULT_LISTPATTERN "#?.cliplist"
#define LIST_EXT ".cliplist"

struct Library *AslBase = NULL;
static struct FileRequester *fr = NULL;

struct TagItem tags[] = {
	ASLFR_Window,				NULL,
	ASLFR_InitialLeftEdge,	DEFAULT_LEFT,
	ASLFR_InitialTopEdge,	DEFAULT_TOP,
	ASLFR_InitialWidth,		DEFAULT_WIDTH,
	ASLFR_InitialHeight,		DEFAULT_HEIGHT,
	ASLFR_InitialDrawer,		NULL,
	ASLFR_InitialFile,      NULL,
	ASLFR_InitialPattern,	NULL,
	ASLFR_TitleText,			NULL, 
	ASLFR_DoSaveMode,			FALSE,
	ASLFR_SleepWindow,		TRUE,
	ASLFR_Flags1,				FRF_PRIVATEIDCMP+FRF_DOMULTISELECT+FRF_DOPATTERNS,
	ASLFR_RejectIcons,		TRUE,
	TAG_DONE
};

/*** indices for changeable stuff in requester tags ***/
#define FR_WINDOW   0
#define FR_LEFT     1
#define FR_TOP      2
#define FR_WIDTH    3
#define FR_HEIGHT   4
#define FR_DRAWER   5
#define FR_NAME     6
#define FR_PATTERN  7
#define FR_TITLE    8
#define FR_SAVE     9

/*** texts for requester title ***/
static char LoadText[] = "Load Multiple Clips:";
static char LoadListText[] = "Load Clips List:";
static char SaveListText[] = "Save Clips List:";
static char SelectListText[] = "Select Clips for List:";

/*** reused texts for msgbox() gadgets ***/
static char ContinueText[] = "Continue";

/*******************************************/
static void __regargs savestuff(void)
{
	Clipper.left = fr->fr_LeftEdge;
	Clipper.top = fr->fr_TopEdge;
	Clipper.width = fr->fr_Width;
	Clipper.height = fr->fr_Height;
	strcpy(Clipper.drawer,fr->fr_Drawer);
}

/*******************************************/
static void __regargs settags(char *title,long save)
{
	tags[FR_WINDOW].ti_Data = (ULONG)awin;
	tags[FR_LEFT].ti_Data = Clipper.left;
	tags[FR_TOP].ti_Data = Clipper.top;
	tags[FR_WIDTH].ti_Data = Clipper.width;
	tags[FR_HEIGHT].ti_Data = Clipper.height;
	tags[FR_DRAWER].ti_Data = (ULONG)Clipper.drawer;
	tags[FR_TITLE].ti_Data = (ULONG)title;
	tags[FR_SAVE].ti_Data = save;
	if (save) tags[FR_NAME].ti_Data = NULL;
}

/*==========================================================================
* CloseWindowSafely
*=========================================================================*/

static void __inline CloseWindowSafely(struct Window *w)

{
	struct IntuiMessage *msg,*succ;

	msg=(struct IntuiMessage *)w->UserPort->mp_MsgList.lh_Head;
	while(msg->ExecMessage.mn_Node.ln_Succ!=NULL) {
		succ=(struct IntuiMessage *)msg->ExecMessage.mn_Node.ln_Succ;
		if(msg->IDCMPWindow==w) {
			Remove((struct Node *)msg);
			ReplyMsg((struct Message *)msg);
		}
		msg=succ;
	}
	w->UserPort=NULL;
	ModifyIDCMP(w,0);
	functions->FlashyCloseWindow(w);
}

/*==========================================================================
* closewindow
*=========================================================================*/

static long __stdargs __saveds closewindow(void)

{
	if (awin) {
		if (awin->MenuStrip) ClearMenuStrip(awin);
		functions->EmbossOff(awin,LOAD);
		functions->EmbossOff(awin,LOADLIST);
		functions->EmbossOff(awin,SAVELIST);
		NewWindowStructure1.LeftEdge = Clipper.access.left = awin->LeftEdge;
		NewWindowStructure1.TopEdge = Clipper.access.top = awin->TopEdge;
		Forbid();
		CloseWindowSafely(awin);
		awin = NULL;
		Permit();
	}
	return(1);
}
 
/*==========================================================================
* openwindow
*=========================================================================*/

static long __stdargs __saveds openwindow(void)

{
	if (!awin) {
		NewWindowStructure1.Screen = functions->screen;
		NewWindowStructure1.IDCMPFlags = 0;
		NewWindowStructure1.Flags &= ~0xF;
		NewWindowStructure1.DetailPen = NewWindowStructure1.BlockPen = 0;
		awin = functions->FlashyOpenWindow(&NewWindowStructure1);
		if (awin) {
			functions->EmbossWindowOn(awin,WINDOWCLOSE|WINDOWDEPTH|WINDOWDRAG,
			                          WTITLE,(short)-1,(short)-1,0,0);
			awin->UserPort = functions->window->UserPort;
			ModifyIDCMP(awin,functions->window->IDCMPFlags);
			functions->EmbossOn(awin,LOAD,1);
			functions->EmbossOn(awin,LOADLIST,1);
			functions->EmbossOn(awin,SAVELIST,1);
			functions->DrawEmbossed(awin,LOAD);
			functions->DrawEmbossed(awin,LOADLIST);
			functions->DrawEmbossed(awin,SAVELIST);
			SetWindowTitles(awin,(UBYTE *)-1,WTITLE);
			SetMenuStrip(awin,&MenuList1);
			if (!fr) {
				settags(LoadText,FALSE);
				fr = (struct FileRequester *)AllocAslRequest(ASL_FileRequest,tags);
				if (!fr) {
					functions->msgbox("Can't allocate file requester!",ContinueText,
				                     NULL,NULL,1,BP_LGREY,BP_RED,BP_BLUE);
					return(0);
				}
			}
		}
//dprintf("functions=%ld\n",functions);
	}
	return((long)awin);
}

/*****************************************/
static long  __regargs loadclip(char *filename)
{
	long file;
	struct Clip *clip;      // the clip that gets loaded from disk
	struct Clip volatile c; // a local clip for mucking with
	struct Clip *cp = NULL;// = &c;   // a pointer to the local clip....
	long result;
	struct String *string;
	char text[116];

	if (file = functions->fastopen(filename,MODE_OLDFILE)) {
		if (clip = functions->loadclip(file)) {
			result = functions->clipboard(CLIP_PUT,clip);
			if (result != CLIP_OK) {
				sprintf(text,"Can't put clip %s.",filename);
				result = functions->msgbox(text," Abort ",ContinueText,NULL,1,
				                           BP_LGREY,BP_RED,BP_BLUE);
			}
			else { // try ryan's suggestion that get returns a pointer to the clip
c.begin = 666;
dprintf("cp=%ld\n",cp);
strncpy(text,clip->name->string,clip->name->length);
dprintf("put clip @ %ld name is %s\n",clip,text);
				if (functions->clipboard(CLIP_GET,cp) == CLIP_OK) {
//					strncpy(text,clip->name->string,clip->name->length);
					text[clip->name->length] = 0;
dprintf("got clip %ld c.begin=%ld c.events.first=%ld\n",cp,c.begin,c.events.first);
					if (string = functions->allocstring(text)) {
dprintf("set cp name to %s???\n",text);
						functions->freestring(cp->name);
						cp->name = string;
					}
					strncpy(text,cp->name->string,cp->name->length);
					text[cp->name->length] = 0;
dprintf("cp name now %s\n",text);
if (functions->clipboard(CLIP_GET,cp) == CLIP_OK) {
 strncpy(text,cp->name->string,cp->name->length);
 text[cp->name->length] = 0;
dprintf("got cp @ %ld; name is %s\n\n",cp,text);
}
				}
			}
			functions->clearclip(clip);
			functions->myfree((char *)clip,sizeof(struct Clip));
		}
		functions->fastclose(file);
	}
	else {
		sprintf(text,"Can't open %s.",filename);
		result = functions->msgbox(text," Hmmmm ",NULL,NULL,1,BP_LGREY,BP_RED,BP_BLUE);
	}
	return(result);
}


static char filename[100];


/**************************************************/
static void __inline savelist(void)

{
	struct Name *name;
	struct Name *namelist = NULL;
	long file;
	struct WBArg *wbarg;
	ULONG filecount;
	ULONG i;

	filecount = fr->rf_NumArgs;
	wbarg = fr->rf_ArgList;
	for ( i=0 ; i < filecount ; i++ ) {
		if (name = (struct Name *)functions->myalloc(sizeof(struct Name),0)) {
			strcpy(filename,fr->rf_Dir);
			if (AddPart(filename,wbarg[i].wa_Name,100)) {
				if (name->name = functions->myalloc(strlen(filename)+1,0)) {
					name->next = namelist;
					namelist = name;
					strcpy(name->name,filename);
				}
				else {
					functions->myfree((char *)name,sizeof(struct Name));
					break;
				}
			}
			else {
				functions->myfree((char *)name,sizeof(struct Name));
				break;
			}
		}
	}
	if (i == filecount) { //allocated all names
		settags(SaveListText,TRUE);
		tags[FR_PATTERN].ti_Data = (ULONG)DEFAULT_LISTPATTERN;
		if (AslRequest(fr,tags)) {
			strcpy(filename,fr->rf_Dir);
			if (AddPart(filename,fr->rf_File,100)) {
//dprintf("filepart=%s\n",FilePart(filename));
				if (Stricmp(FilePart(filename),LIST_EXT) != 0) {
					strcat(filename,LIST_EXT);
				}
				file = functions->fastopen(filename,MODE_NEWFILE);
				if (file) {
					i = LISTID;
					functions->fastwrite(file,(char *)&i,4);
					functions->fastwrite(file,(char *)&filecount,4);
					for ( name = namelist ; name ; name = name->next ) {
						i = strlen(name->name);
						functions->fastwrite(file,(char *)&i,4);
						functions->fastwrite(file,name->name,i);
					}
					functions->fastclose(file);
				}
			}
		}
	}
	else { // not enough memory to build the list of filenames
		functions->msgbox("Not enough memory to build filename list!",
		                  ContinueText,NULL,NULL,1,BP_LGREY,BP_RED,BP_BLUE);
	}
	for ( name = namelist ; name ; name = namelist ) {
		namelist = name->next;
		functions->myfree(name->name,strlen(name->name)+1);
		functions->myfree((char *)name,sizeof(struct Name));
	}
}

/*****************************************************/
static void __inline loadlist(void)
{
	long file;
	struct WBArg *wbarg;
	ULONG filecount;
	ULONG x;
	ULONG i;
	char clipname[100];

	wbarg = fr->rf_ArgList;
	for ( i=0 ; i < fr->rf_NumArgs ; i++ ) {
		strcpy(filename,fr->rf_Dir);
		if (AddPart(filename,wbarg[i].wa_Name,100)) {
			file = functions->fastopen(filename,MODE_OLDFILE);
			if (file) {
				functions->fastread(file,(char *)&x,4);
				if (x == LISTID) {
					functions->fastread(file,(char *)&filecount,4);
					for ( ; filecount ; filecount-- ) {
						functions->fastread(file,(char *)&x,4);
						functions->fastread(file,clipname,x);
						clipname[x] = '\0';
						if (!loadclip(clipname)) {
							break;
						}
					}
				}
				else {
					functions->msgbox("Not a cliplist file!",
		                          ContinueText,NULL,NULL,1,BP_LGREY,BP_RED,BP_BLUE);
				}
				functions->fastclose(file);
			}
		}
	}
}

/*==========================================================================
* editwindow
*=========================================================================*/

static int __stdargs __saveds editwindow(struct IntuiMessage *message)

{
	struct Gadget *gadget = (struct Gadget *)message->IAddress;
	long code = message->Code;
	long class = message->Class;
	struct WBArg *wbarg;
	ULONG i;

	ReplyMsg((struct Message *)message);
	class = functions->SystemGadgets(awin,class,gadget,code);

	if (class == CLOSEWINDOW) {
		closewindow();
	}
	else if (class == GADGETUP) {
		switch (gadget->GadgetID) {
			case LOAD :
				settags(LoadText,FALSE);
				tags[FR_PATTERN].ti_Data = (ULONG)DEFAULT_PATTERN;
				if (AslRequest(fr,tags)) {
					if (fr->rf_NumArgs) {
//dprintf("picked %ld files\n",fr->rf_NumArgs);
						wbarg = fr->rf_ArgList;
						for ( i = 0 ; i < fr->rf_NumArgs ; i++ ) {
							strcpy(filename,fr->rf_Dir);
							if (AddPart(filename,wbarg[i].wa_Name,100)) {
//dprintf("  %s\n",filename);
								if (!loadclip(filename)) break;
							}
						}
					}
				}
				savestuff();
				break;

			case LOADLIST :
				settags(LoadListText,FALSE);
				tags[FR_PATTERN].ti_Data = (ULONG)DEFAULT_LISTPATTERN;
				if (AslRequest(fr,tags)) {
					if (fr->rf_NumArgs) {
//dprintf("picked %ld files\n",fr->rf_NumArgs);
						loadlist();
					}
				}
				savestuff();
				break;

			case SAVELIST :
				settags(SelectListText,FALSE);
				tags[FR_PATTERN].ti_Data = (ULONG)DEFAULT_PATTERN;
				if (AslRequest(fr,tags)) {
					savelist();
				}
				savestuff();
				break;
		}
	}
	return(1);
}

/*==========================================================================
* savedata
*
*  INPUT: file id, pointer to Environment
* RETURN: 0 if successful; 1 if not
*
* EFFECT: writes accessory data to a .song file
*=========================================================================*/

static long __stdargs __saveds savedata(long file, struct Environment *env)
{
	long size;

	size = Clipper.access.id;
	if (functions->fastwrite(file,(char *)&size,4) == -1) return(1);
	size = DATA_SIZE;
	if (functions->fastwrite(file,(char *)&size,4) == -1) return(1);
	if (functions->fastwrite(file,(char *)&Clipper.left,size-4) == -1)
		return(1);
	if (functions->fastwrite(file,((char *)&Clipper.access.left),2) == -1) 
		return(1);
	if (functions->fastwrite(file,((char *)&Clipper.access.top),2) == -1)
		return(1);

	return(0);
}

/*==========================================================================
* loaddata
*
*  INPUT: file id, pointer to Environment, size of data to read
* RETURN: 1
*
* EFFECT: reads accessory data from .song file
*=========================================================================*/

static long __stdargs __saveds loaddata(long file,struct Environment *env,
                                        long size)

{
	functions->fastread(file,(char *)&Clipper.left,size-4);
	functions->fastread(file,(char *)&Clipper.access.left,4);
	return(1);
}

/***************************************************/
static long __stdargs __saveds remove_accessory(void)
{
	if (fr) {
		FreeAslRequest(fr);
		fr = NULL;
	}
	if (AslBase) {
		CloseLibrary(AslBase);
		AslBase = NULL;
	}
	return(1);
}


/***********************************************************/
struct Accessory * __stdargs __saveds inittoolmaster()

{
	struct EasyStruct es = {
		sizeof(struct EasyStruct),
		0,
		"ClipThing Accessory",
		"Need asl.library",
		"Whoops",
	};

	if (AslBase = OpenLibrary(AslName,0)) {
		memset((char *)&Clipper,0,sizeof(struct Accessory));
		Clipper.access.left = NewWindowStructure1.LeftEdge;
		Clipper.access.top =  NewWindowStructure1.TopEdge;
		Clipper.access.id = Clps_ID;
		Clipper.access.image = &ClipRenderImage;
		Clipper.access.onimage = &ClipSelectImage;
		Clipper.access.open = openwindow;
		Clipper.access.close = closewindow;
		Clipper.access.edit = editwindow;
		Clipper.access.remove = remove_accessory;
		Clipper.access.load = loaddata;
		Clipper.access.save = savedata;

		Clipper.left = DEFAULT_LEFT;
		Clipper.top = DEFAULT_TOP;
		Clipper.width = DEFAULT_WIDTH;
		Clipper.height = DEFAULT_HEIGHT;
		strcpy(Clipper.drawer,functions->bppdir);
		strcpy(Clipper.access.name,ACC_NAME);
		return(&Clipper.access);
	}
	else {
		EasyRequestArgs(NULL,&es,NULL,NULL);
		return(NULL);
	}
}
